﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;

namespace StoryMaker.Plugins
{
    [AttributeUsage(AttributeTargets.Assembly, AllowMultiple = true, Inherited = true)]
    public sealed class LocalizationResourceAttribute : Attribute, IResourceAttribute
    {
        public CultureInfo Culture { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public string ResourceClassPath { get; set; }

        public LocalizationResourceAttribute(string culture)
        {
            this.Culture = new CultureInfo(culture);
        }
    }
}
